#include "AD7192.h"
void Delay(int cound);
unsigned long int AD7192Registers[8]={0,0,0,0,0,0,0,0};
unsigned long int AD7192Data = 0,AD7192Data1 = 0;
/********************************************************************************
ƣvoid ADSpiOperation(unsigned char* WriteBuffer, unsigned char *ReadBuffer, 
															unsigned char NumberOfByte)
: AD7192
˵
˵ 
********************************************************************************/
void ADSpiOperation(unsigned char* WriteBuffer, unsigned char *ReadBuffer, unsigned char NumberOfByte)
{
	unsigned	char	WriteData, ReadData;
  unsigned	char	i, j;
	
	ADSCK_0();	
	for(i=0; i<NumberOfByte; i++)
 	{
	 	WriteData = *(WriteBuffer + i);
		ReadData = 0;

		for(j=0; j<8; j++)
		{
			ADSCK_1();

			if(0x80 == (WriteData & 0x80))
			{
				ADOUT_1();	 
			}
			else
			{
				ADOUT_0();	  
			}
			WriteData = WriteData << 1;

			ADSCK_0();

			ReadData = (ReadData<<1) | GetBitAD7192(); 
		}
		*(ReadBuffer + i)= ReadData;
	}  
	ADSCK_1();

}
/********************************************************************************
ƣvoid AD7192Initialization(void)
: AD7192ʼ
˵
˵ 
********************************************************************************/
void AD7192Initialization(void)
{
	AD7192SoftwareReset();
	AD7192InternalZeroScaleCalibration();
	AD7192InternalFullScaleCalibration();
}
/********************************************************************************
ƣvoid AD7192SoftwareReset(void)
: AD7192λ
˵
˵ 
********************************************************************************/
void AD7192SoftwareReset(void)
{
	
	unsigned char WriteBuf[1];
	unsigned char ReadBuf[1];
	unsigned char i;

	ADCS_0();
	ADSYNC_1();
	WriteBuf[0]	= 0xFF;	 

	for(i=0; i<5; i++)
	{

		ADSpiOperation(WriteBuf, ReadBuf, 1);

	}
	ADCS_1();
}
/********************************************************************************
ƣunsigned char WriteToAD7192ViaSPI(const unsigned char RegisterStartAddress, 
												const unsigned char NumberOfRegistersToWrite, unsigned long int *DataBuffer, 
												const unsigned char OffsetInBuffer)
: AD7192д
˵
˵ 
********************************************************************************/
unsigned char WriteToAD7192ViaSPI(const unsigned char RegisterStartAddress, const unsigned char NumberOfRegistersToWrite, unsigned long int *DataBuffer, const unsigned char OffsetInBuffer)
{
	unsigned char WriteBuf[4];
	unsigned char ReadBuf[4];
	unsigned char i;

	ADCS_0();

	for(i=0; i<NumberOfRegistersToWrite; i++)
	{
		WriteBuf[0]	= WEN|RW_W|((RegisterStartAddress + i)<<3)|CREAD_DIS;
		WriteBuf[1] = DataBuffer[RegisterStartAddress + i]>>16;
		WriteBuf[2] = DataBuffer[RegisterStartAddress + i]>>8;
		WriteBuf[3]	= DataBuffer[RegisterStartAddress + i];
		ADSpiOperation(WriteBuf, ReadBuf, 4);
	}
	ADCS_1();
	return 0;
}
/********************************************************************************
ƣunsigned char ReadFromAD7192ViaSPI(const unsigned char RegisterStartAddress, 
								const unsigned char NumberOfRegistersToRead, unsigned long int *DataBuffer, 
								const unsigned char OffsetInBuffer)
: AD7192
˵
˵ 
********************************************************************************/
unsigned char ReadFromAD7192ViaSPI(const unsigned char RegisterStartAddress, const unsigned char NumberOfRegistersToRead, unsigned long int *DataBuffer, const unsigned char OffsetInBuffer)
{
	unsigned char WriteBuf[4];
	unsigned char ReadBuf[4];
	unsigned char i;

	ADCS_0();
	for(i=0; i < NumberOfRegistersToRead; i++)
	{

		WriteBuf[0] = WEN|RW_R|((RegisterStartAddress + i)<<3)|CREAD_DIS;	 

		ADSpiOperation(WriteBuf, ReadBuf, 1);

		WriteBuf[0] = NOP;
		WriteBuf[1]	= NOP;
		WriteBuf[2]	= NOP;
		WriteBuf[3]	= NOP;

		switch(RegisterStartAddress + i){

			case REG_ID		 :
			case REG_COM_STA : 
			case REG_GPOCON  :
				ADSpiOperation(WriteBuf, ReadBuf, 1);
				DataBuffer[OffsetInBuffer + i ] = ReadBuf[0];
				break;
				
			case REG_MODE    : 
			case REG_CONF	 : 
			case REG_OFFSET  :
			case REG_FS		 : 
				ADSpiOperation(WriteBuf, ReadBuf, 3);	   
				DataBuffer[OffsetInBuffer + i ] = ReadBuf[0];
				DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[1];
				DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[2];  
				break;
				
			case REG_DATA	 : 
				if (AD7192Registers[REG_MODE] & DAT_STA_EN)	{

					ADSpiOperation(WriteBuf, ReadBuf, 4);	  
					DataBuffer[OffsetInBuffer + i ] = ReadBuf[0];
					DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[1];
					DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[2];					
					DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[3];
					break;
					}
				else {

					ADSpiOperation(WriteBuf, ReadBuf, 3);	   //do not transfer the status contents after read data register 
					DataBuffer[OffsetInBuffer + i ] = ReadBuf[0];
					DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[1];
					DataBuffer[OffsetInBuffer + i ] = (DataBuffer[OffsetInBuffer + i ]<<8) + ReadBuf[2];
					break;
					}
	
			default			 : 
					break;
															
		}
	}
	ADCS_1();
	return 0;
}
/********************************************************************************
ƣvoid AD7192StartContinuousRead(void)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192StartContinuousRead(void)
{

	unsigned char WriteBuf[1];
	unsigned char ReadBuf[1];

	ADCS_0();

	WriteBuf[0] = WEN|RW_R|(REG_DATA<<3)|CREAD_EN;

	ADSpiOperation(WriteBuf, ReadBuf, 1);	

}
/********************************************************************************
ƣunsigned long int AD7192ContinuousRead(void)
: AD7192
˵
˵ 
********************************************************************************/
unsigned long int AD7192ContinuousRead(void)
{
	unsigned char WriteBuf[4];
	unsigned char ReadBuf[4];
	unsigned long int DataBuffer;
	unsigned long i = 0;

	WriteBuf[0] = NOP;
	WriteBuf[1] = NOP;	
	WriteBuf[2] = NOP;
	WriteBuf[3]	= NOP;

	ADCS_0();
	while(GetBitAD7192()== 0 && (i++ < 10000));			
	while(GetBitAD7192()== 1 && (i++ < 10000));			//	waiting the 1st RDY failling edge;

	if ((AD7192Registers[REG_MODE] & DAT_STA_EN) == DAT_STA_EN)	{

		ADSpiOperation(WriteBuf, ReadBuf, 4);	  
		DataBuffer = ReadBuf[0];
		DataBuffer = (DataBuffer<<8) + ReadBuf[1];
		DataBuffer = (DataBuffer<<8) + ReadBuf[2];
		DataBuffer = (DataBuffer<<8) + ReadBuf[3];
		}
	else {

		ADSpiOperation(WriteBuf, ReadBuf, 3);	   //do not transfer the status contents after read data register 
		DataBuffer = ReadBuf[0];
		DataBuffer = (DataBuffer<<8) + ReadBuf[1];
		DataBuffer = (DataBuffer<<8) + ReadBuf[2];
		}

	return DataBuffer;
}
/********************************************************************************
ƣunsigned long int AD7192ReadConvertingData(void)
: AD7192
˵
˵ 
********************************************************************************/
unsigned long int AD7192ReadConvertingData(void)
{
	unsigned char WriteBuf[4];
	unsigned char ReadBuf[4];
	unsigned long int DataBuffer;
	unsigned long i = 0;

	ADCS_0();
	WriteBuf[0] = WEN|RW_R|((REG_DATA)<<3)|CREAD_DIS;	 

	ADSpiOperation(WriteBuf, ReadBuf, 1);

	WriteBuf[0] = NOP;
	WriteBuf[1] = NOP;	
	WriteBuf[2] = NOP;
	WriteBuf[3]	= NOP;

	while(GetBitAD7192()== 0 && (i++ < 10000) );			
	while(GetBitAD7192()== 1 && (i++ < 10000));			//	waiting the 1st RDY failling edge;

	if ((AD7192Registers[REG_MODE] & DAT_STA_EN) == DAT_STA_EN)	{

		ADSpiOperation(WriteBuf, ReadBuf, 4);	  
		DataBuffer = ReadBuf[0];
		DataBuffer = (DataBuffer<<8) + ReadBuf[1];
		DataBuffer = (DataBuffer<<8) + ReadBuf[2];
		DataBuffer = (DataBuffer<<8) + ReadBuf[3];
		}
	else {

		ADSpiOperation(WriteBuf, ReadBuf, 3);	   //do not transfer the status contents after read data register 
		DataBuffer = ReadBuf[0];
		DataBuffer = (DataBuffer<<8) + ReadBuf[1];
		DataBuffer = (DataBuffer<<8) + ReadBuf[2];
		}

	return DataBuffer;
}
/********************************************************************************
ƣvoid AD7192ExitContinuousRead(void)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192ExitContinuousRead(void)
{

	unsigned char WriteBuf[1];
	unsigned char ReadBuf[1];
	unsigned long i = 0;

	while(GetBitAD7192()== 0 && (i++ < 10000) );		
	while(GetBitAD7192()== 1 && (i++ < 10000));			//	waiting the 1st RDY failling edge;

	WriteBuf[0]	= WEN|RW_R|(REG_DATA<<3)|CREAD_DIS;

	ADSpiOperation(WriteBuf, ReadBuf, 1);		

	ADCS_1();
}
/********************************************************************************
ƣvoid AD7192InternalZeroScaleCalibration(void)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192InternalZeroScaleCalibration(void)
{	
	unsigned long i = 0;
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN2|AIN1_AIN2|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

	AD7192Registers[REG_MODE] = MODE_INZCL|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;		
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);
	
	ADCS_0();
	while(GetBitAD7192()== 1 && (i++ < 10000) );			//	wait until RDY = 0;
	ADCS_1();


}
/********************************************************************************
ƣvoid AD7192InternalFullScaleCalibration(void)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192InternalFullScaleCalibration(void)
{
	unsigned long i = 0;
	
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN2|AIN1_AIN2|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_MODE] = MODE_INFCL|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_2|SINGLECYCLE_DIS|REJ60_DIS|0x080;		
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);
		
	ADCS_0();
	while(GetBitAD7192()==1 && (i++ < 10000) );	   //	wait until RDY = 0;
	ADCS_1();
}
/********************************************************************************
ƣvoid AD7192ExternalZeroScaleCalibration(void)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192ExternalZeroScaleCalibration(void)
{
	unsigned long i = 0;
	
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN2|AIN1_AIN2|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

//	The user should connect the system zero-scale input to the channel input pins as selected by the CH7 to CH0 bits in the configuration register	
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_MODE] = MODE_SYSZCL|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;		
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);

	ADCS_0();
	while(GetBitAD7192()==1 && (i++ < 10000) );//	wait until RDY = 0;
	ADCS_1();

}
/********************************************************************************
ƣvoid AD7192ExternalFullScaleCalibration(void)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192ExternalFullScaleCalibration(void)
{
	unsigned long i = 0;
	
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN2|AIN1_AIN2|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

//	The user should connect the system full-scale input to the channel input pins as selected by the CH7 to CH0 bits in the configuration register
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_MODE] = MODE_SYSFCL|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_2|SINGLECYCLE_DIS|REJ60_DIS|0x080;		
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);

	ADCS_0();
	while(GetBitAD7192()== 1 && (i++ < 10000) );			//	wait until RDY = 0;
	ADCS_1();

}
/********************************************************************************
ƣvoid AD7192StartSingleConvertion(unsigned long int Channels)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192StartSingleConvertion(unsigned long int Channels)
{

	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN2|Channels|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);
	AD7192Registers[REG_MODE] = MODE_SING|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);

}
/********************************************************************************
ƣvoid AD7192StartContinuousConvertion(unsigned long int Channels)
: AD7192
˵
˵ 
********************************************************************************/
void AD7192StartContinuousConvertion(unsigned long int Channels)
{

	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;		//Output Rate =	MCLK/1024/128 without chop
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN2|Channels|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1
	WriteToAD7192ViaSPI(REG_MODE, 2, AD7192Registers, REG_MODE);

}
/********************************************************************************
ƣunsigned long int AD7192ReadAIN1_AIN2(void)
: AD7192
˵
˵ 
********************************************************************************/
unsigned long int AD7192ReadAIN1_AIN2(void)
{
	/*AD7192Data =0;
	AD7192Data1=0;
*/
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;

	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x050;		//Output Rate =	MCLK/1024/128 without chop

	//AD7192Registers[REG_MODE] = MODE_SING|DAT_STA_DIS|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;
//	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_DIS|INCLK_MCLK2TRI|SINC_4|ENPAR_DIS|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x060;
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN1|AIN1_AIN2|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN1|TEMP|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

	AD7192Data = AD7192ReadConvertingData();
	Delay(500);
	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;

	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_EN|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x01;		//Output Rate =	MCLK/1024/128 without chop

		//AD7192Registers[REG_MODE] = MODE_SING|DAT_STA_DIS|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;
	//	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_DIS|INCLK_MCLK2TRI|SINC_4|ENPAR_DIS|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x060;
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN1|AIN3_AIN4|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN1|TEMP|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

	AD7192Data1 = AD7192ReadConvertingData();
//	return AD7192Data1;

}

/********************************************************************************
ƣunsigned long int AD7192ReadTemperature(void)
: AD7192
˵
˵ 
********************************************************************************/
unsigned long int AD7192ReadTemperature(void)
{

	AD7192Registers[REG_MODE] = 0;
	AD7192Registers[REG_CONF] = 0;
	AD7192Registers[REG_MODE] = MODE_SING|DAT_STA_DIS|INCLK_MCLK2EN|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x080;
//	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_DIS|INCLK_MCLK2TRI|SINC_4|ENPAR_DIS|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x060;
	WriteToAD7192ViaSPI(REG_MODE, 1, AD7192Registers, REG_MODE);
	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN1|TEMP|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;
	WriteToAD7192ViaSPI(REG_CONF, 1, AD7192Registers, REG_CONF);

	//AD7192Data = AD7192ReadConvertingData();

	return ;//AD7192Data;

}
/********************************************************************************
ƣfloat RealTemperature(unsigned long int TemperatureCode)
: AD7192¶
˵
˵ 
********************************************************************************/
float RealTemperature(unsigned long int TemperatureCode)
{
	float temp = 0.0;
	temp = (TemperatureCode-0x800000)/2815.0-273;
	return temp;
}
