#include <msp430.h> 
//#include "ADuC7026.h"
//#include "ADuC7026Driver.h"
#include "AD7192.h"
//#include "stdio.h"
/*
 * main.c
 */
//unsigned long int AD7192Data = 0,AD7192Data1 = 0;
void Delay(int cound);


int main(void) {

    	int i;
    	int NumberOfDataToContinuousRead = 10;
    	int NumberOfDataToContinuousConvertion = 4;
    	float AD7192Temperature = 0.0;

    	WDTCTL = WDTPW | WDTHOLD;
    	P1DIR |=BIT0+BIT2+BIT4+BIT5;
    	P1OUT |=BIT0+BIT2+BIT4+BIT5;
    	P1OUT&=~BIT3;
    	P1SEL=0X00;
    	AD7192Initialization();


    	AD7192InternalZeroScaleCalibration();
    	AD7192InternalFullScaleCalibration();
    	AD7192Registers[REG_MODE] = 0;
    	AD7192Registers[REG_CONF] = 0;
    	AD7192Registers[REG_MODE] = MODE_CONT|DAT_STA_EN|INCLK_MCLK2TRI|SINC_4|ENPAR_EN|CLK_DIV_DIS|SINGLECYCLE_DIS|REJ60_DIS|0x010;		//Output Rate =	MCLK/1024/128 without chop
    	AD7192Registers[REG_CONF] = CHOP_DIS|REF_IN1|AIN1_AIN2|BURN_DIS|REFDET_DIS|BUF_DIS|UB_BI|GAIN_1;	// Gain = 1

    	WriteToAD7192ViaSPI(REG_MODE, 2, AD7192Registers, REG_MODE);

    	AD7192Registers[REG_MODE] = 0;
    	AD7192Registers[REG_CONF] = 0;
    	ReadFromAD7192ViaSPI(REG_MODE, 2, AD7192Registers, REG_MODE);

    	AD7192StartContinuousRead();
    	for(i=0; i < NumberOfDataToContinuousRead; i++)
    	{
    		AD7192Data = AD7192ContinuousRead();
    	}
    	AD7192ExitContinuousRead();

    	AD7192StartSingleConvertion(AIN1_AIN2);

    	AD7192Data = AD7192ReadConvertingData();
    	ReadFromAD7192ViaSPI(REG_DATA, 1, AD7192Registers, REG_DATA);
    	AD7192StartContinuousConvertion(AIN3_AIN4);
    	AD7192Data = AD7192ReadConvertingData();
    	ReadFromAD7192ViaSPI(REG_DATA, 1, AD7192Registers, REG_DATA);
    	for(i=0; i < NumberOfDataToContinuousConvertion; i++)
    	{
    		AD7192Registers[REG_DATA] = 0;
    		AD7192Data = AD7192ReadConvertingData();
    	}
    	AD7192Data = AD7192ReadTemperature();
    	AD7192Temperature = (float)RealTemperature(AD7192Data);

    	while(1)
    	{


    		AD7192StartContinuousConvertion(AIN1_AIN2);
    		Delay(100);
    		AD7192Data = AD7192ReadConvertingData();

    		;}
	//return 0;
}

void Delay(int cound)
{
	while(cound>0)
	{
		long int i;
		for(i=500;i>0;i--)
			{
			;
			}
		cound--;
	}
}
